.im man.im
.NM archive maintain file archive
.SY archive -cmd aname [ file ... ]
.FU
.ital archive
manages any number of member files in a single file,
.ital aname,
with sufficient information that members may be selectively added, extracted,
replaced, or deleted from the collection.
.ital -cmd
is a code that determines the operation to be performed:

.nf
-c    create a new archive with named members
-d    delete named members from archive
-p    print named members on standard output
-t    print table of archive contents
-u    update named members or add at end
-x    extract named members from archive

.fi
In each case, the "named members" are the zero or more filenames
given as arguments following
.ital aname.
If no arguments follow, then the "named members" are taken as
.sf 6
all
.sf 0
of the files in the archive, except for the delete command
.ital -d,
which is not so rash.
.ital archive
complains if a file is named twice or cannot be accessed.
.br
The
.ital -t
command writes one line to the output for each named member,
consisting of
the member name
and a string representation of the file length, separated
by a blank.
.br
The
create command
.ital -c
makes a new archive containing the named files.
The
update command
.ital -u
replaces existing named members and adds new files onto
the end of an existing archive.
Create and update read from, and extract
writes to, files whose names are the same
as the member names in the archive.
An intermediate version of the new archive file is first written to the
file
.ital artemp;
hence this filename should be avoided.

An archive is a concatenation of zero or more entries,
each consisting of a header and an exact copy of the original file.
The header format is

.bold -h-
.ital name length

.EG
To replace two files in an existing archive, add
a new one, then print the table of contents:
.Q1
archive -u archfile old1 old2 new1
archive -t archfile
.Q2
.FUTURE
It sure would be nice if the date last modified was kept for a file,
and extract would keep that date.  As it stands now, doing an
archive causes time/date information to be lost.
